package com.dsic.gj_erp.bean.jhgk;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.dsic.gj_erp.bean.jcsj.DmBom;
import com.dsic.gj_erp.pc.Constant;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;

/**
 * <p>
 * 
 * </p>
 *
 * @author xn
 * @since 2023-11-21
 */
@Data
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="DmSygdMx对象", description="")
public class DmSygdMx implements Serializable {

    private static final long serialVersionUID=1L;

    @ApiModelProperty(value = "产品")
    private String dcCh;

    @ApiModelProperty(value = "数据来源船")
    private String dcCh1;

    @ApiModelProperty(value = "批量")
    private String dcPl;

    @ApiModelProperty(value = "领取类型")
    @TableField("LQLB")
    private String lqlb;

    @ApiModelProperty(value = "套料图号")
    private String tzbh;

    @ApiModelProperty(value = "规格")
    private String wpgg;

    @ApiModelProperty(value = "材质")
    private String wpxh;

    @ApiModelProperty(value = "划线长度(米)")
    private volatile Double hxcd;
    private volatile Double dmcd;
    private String dmrq;
    private String pkrq;
    private String llrq;
    @ApiModelProperty(value = "切割长度（米）")
    private Double qgcd;

    @ApiModelProperty(value = "曲标识")
    private String qbs;
    private String qjgrq;

    @ApiModelProperty(value = "坡口类型")
    private Double pklx;

    @ApiModelProperty(value = "坡口长度")
    private volatile Double pkcd;

    @ApiModelProperty(value = "零件数量")
    private Double ljsl;

    @ApiModelProperty(value = "组立")
    private String zl;
    @ApiModelProperty(value = "钢加大组结束")
    private String gjjsDz;


    @ApiModelProperty(value = "加工类型")
    private String lx;

    @ApiModelProperty(value = "型材米数")
    private Double xcms;

    @ApiModelProperty(value = "跨位")
    private String kw;

    @ApiModelProperty(value = "上料日期")
    private String slrq;

    @ApiModelProperty(value = "型材抛丸日期")
    private String xcpw;

    private String slsb;

    @ApiModelProperty(value = "上料人员")
    private String slry;

    @ApiModelProperty(value = "抛丸")
    private String pw;

    @ApiModelProperty(value = "抛丸人员")
    private String pwry;

    @ApiModelProperty(value = "抛丸日期")
    private String pwrq;

    @ApiModelProperty(value = "划线设备")
    private String hxsb;

    @ApiModelProperty(value = "划线人员")
    private String hxry;

    @ApiModelProperty(value = "划线日期")
    private String hxrq;

    @ApiModelProperty(value = "切割设备")
    private String qgsb;

    @ApiModelProperty(value = "切割人员")
    private String qgry;

    @ApiModelProperty(value = "切割日期")
    private String qgrq;

    @ApiModelProperty(value = "切割结束")
    private String qgjs;

    @ApiModelProperty(value = "抛丸设备")
    private String pwsb;

    @ApiModelProperty(value = "分段号")
    @TableField("DC_FD")
    private String dcFd;

    @ApiModelProperty(value = "矫正标识")
    private String jzbs;

    @ApiModelProperty(value = "矫正设备")
    private String jzsb;

    @ApiModelProperty(value = "矫正人员")
    private String jzry;

    @ApiModelProperty(value = "本船号")
    @TableField("dcCh2")
    private String dcCh2;

    @ApiModelProperty(value = "钢加开始")
    private String gjks;

    @ApiModelProperty(value = "时间更新时间")
    private String gxsj;

    @ApiModelProperty(value = "划线空程禅道")
    private Double hxkcCd;

    @ApiModelProperty(value = "切割空程长度")
    private Double qgkcCd;

    @ApiModelProperty(value = "结束时间")
    private String jssj;

    @ApiModelProperty(value = "状态：0编辑 1提交 2下发 3完成 4拖期")
    private String zt;

    @ApiModelProperty(value = "根数")
    private Double xcgs;

    @ApiModelProperty(value = "板材领取重量")
    private Double bclqzl;

    @ApiModelProperty(value = "板材实耗重量")
    private Double bcshzl;

    @ApiModelProperty(value = "板材余料重量")
    private Double bcylzl;

    @ApiModelProperty(value = "板材零件套料重量")
    private Double bcljtlzl;

    @ApiModelProperty(value = "前批余料代")
    private Double bcqpyld;

    private String ylbs;//余料标识

    private String parentId;

    private String ylbhgg;

    @TableId(value = "id", type = IdType.ASSIGN_UUID)
    private String id;

    private String xxr;
    @TableField(exist = false)
    private String beginTime;
    @TableField(exist = false)
    private String endTime;

    private String llsb;
    private String pksb;
    private String dmsb;
    private String qsb;
    private String slgxbm;
    private String pwgxbm;
    private String llgxbm;
    private String hxgxbm;
    private String qggxbm;
    private String pkgxbm;
    private String dmgxbm;
    private String qjggxbm;

    @ApiModelProperty(value = "面板挤边")
    private String mbjb;
    @ApiModelProperty(value = "七垮型材米数")
    private String qkxcms;
    @ApiModelProperty(value = "型材面板")
    private String xcmb;
    @ApiModelProperty(value = "分段需求/小组配送结束")
    private String fdxq;
    @ApiModelProperty(value = "光电结束")
    private String gdjs;
    @ApiModelProperty(value = "备注")
    private String bz;

    private String bzry;
    private String bzrq;
    private String drbs;






    public void 更新排产信息(Constant.工序 _工序,String date){
        switch(_工序){
            case 上料:
                this.slrq=date;
                break;
            case 抛丸:
                this.pwrq=date;
                break;
            case 理料:
                this.llrq=date;
                break;
            case 划线:
                this.hxrq=date;
                break;
            case 切割:
                this.qgrq=date;
                break;
            case 坡口:
                this.pkrq=date;
                break;
            case 型材面板:
                break;
            case 自由边处理:
                break;
            case 曲型:
                this.qjgrq=date;
                break;
            case 打磨:
                this.dmrq=date;
                break;
            case 号料:
                break;
            case 倒棱:
                break;
            case 切端头:
                break;
            case 预配盘:
                break;
            case 光电结束:
                break;
            case 配送:
                break;
        }
    }


    public static DmSygdMx ofWithDmSygdMxlj(DmSygdMxLj lj){
        DmSygdMx mx = new DmSygdMx();
        BeanUtil.copyProperties(lj,mx);
        mx.setId(null);
        mx.setDcCh(lj.getDcch());
        mx.setDcCh2(lj.getMbch());
        mx.setDcCh1(lj.getSjch());
        mx.setDcPl(lj.getPl());
        mx.setTzbh(lj.getTzbh());

        //fixme 看下getFd数据
        mx.setDcFd(lj.getFd());
        if (mx.getDcFd()==null){
            mx.setDcFd(lj.getFd());
        }else if(!mx.getDcFd().equals(lj.getFd())){
            String fd=mx.getDcFd()+" "+lj.getFd();
            mx.setDcFd(fd);
        }

        mx.setJssj(lj.getXzglxq());
        mx.setGjjsDz(lj.getDzglxq());
        mx.setGxsj(DateUtil.date().toString("yyyy/MM/dd"));
        if (StrUtil.isNotEmpty(lj.getTzbh())&&lj.getTzbh().charAt(5)== 'X'){
            mx.setLx("X");
        }else{
            mx.setLx("B");
        }
        mx.setWpxh(lj.getWpcz());
        if (mx.getPkcd()==null){
            mx.setPkcd(lj.getPkcd());
        }else{
            Double pkcd=mx.getPkcd()+lj.getPkcd();
            mx.setPkcd(pkcd);
        }

        if (mx.getDmcd()==null){
            mx.setDmcd(lj.getDmcd());
        }else{
            Double dmcd=mx.getDmcd()+lj.getDmcd();
            mx.setDmcd(dmcd);
        }
        mx.setXcms(lj.getXcshms());
        return mx;
    }

    public void setBomData(DmBom bom){
        this.lqlb=bom.getLqlb();
        this.tzbh=bom.getTzbh();
        this.wpgg=bom.getWpgg();
        this.wpxh=bom.getWpcz();
        try {
            this.hxcd=bom.getHxcd().doubleValue();
        }catch (Exception ignored){}
        try {
            this.dmcd=bom.getDmcd().doubleValue();
        }catch (Exception ignored){}
        try {
            this.qgcd=bom.getQgcd().doubleValue();
        }catch (Exception ignored){}
        this.qbs=bom.getQbs();
        try {
            this.pklx=Double.valueOf(bom.getPklx());
        }catch (Exception ignored){}
        try {
            this.pkcd=bom.getPkcd().doubleValue();
        }catch (Exception ignored){}
        try {
            this.ljsl=bom.getLjsl().doubleValue();
        }catch (Exception ignored){}
        this.zl=bom.getZl();
        try {
            this.xcms=bom.getXcshms().doubleValue();
        }catch (Exception ignored){}
        this.kw=bom.getKw();
        this.dcFd=bom.getFd();
        try {
            this.bclqzl=bom.getBclqzl().doubleValue();
        }catch (Exception ignored){}
        try {
            this.bcshzl=bom.getBcshzl().doubleValue();
        }catch (Exception ignored){}
        try {
            this.bcylzl=bom.getBcylzl().doubleValue();
        }catch (Exception ignored){}
        try {
            this.bcljtlzl=bom.getBcljtlzl().doubleValue();
        }catch (Exception ignored){}
        try {
            this.bcqpyld=bom.getBcqpyld().doubleValue();
        }catch (Exception ignored){}
        this.ylbhgg=bom.getYlbhgg();
    }

}
