package com.dsic.gj_erp.jszb.excel;

import cn.hutool.core.util.StrUtil;
import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import com.dsic.gj_erp.jszb.entity.PartFlowInfo;
import lombok.Getter;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Excel通用监听器
 */
public class ExcelFlowInfoListener extends AnalysisEventListener<PartFlowInfo> {

    @Getter
    List<PartFlowInfo> objectList = new ArrayList<>();

    Map<String,PartFlowInfo> map=new HashMap<>();

    @Getter
    List<String> errors=new ArrayList<>();

    @Override
    public void invoke(PartFlowInfo excelDemo, AnalysisContext analysisContext) {
        String partName=excelDemo.getPartName0()!=null?excelDemo.getPartName0():excelDemo.getPartName();
        if (map.containsKey(partName)){
            String error= StrUtil.format("存在重复数据,检查修改后单独导入即可,零件编号:{},已过滤该行",partName);
            this.errors.add(error);
            return;
        }

        map.put(partName,excelDemo);

        objectList.add(excelDemo);
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext analysisContext) {

    }

}
